{
  Associative arrays for Pascal
  by Bidok (szkuwa [at] o2 [dot] pl)

  version 1.4

  This code is free only for non-commercial usage :)
  
  History:
  ] 1.4 - No variants in TCustomAssocArray class..
          this should speed up code a little
        - now, arrays can be accessed only by string key.. if you want others
          like tab[123] or tab[12.34] you have to write own class
          (maybe i'll add some later)
  ] 1.3 - minor changes in code for delphi support (maybe more is needed..)
        - added new properties: ChildCount, Length and Rank
        - function HaveChilds
  ] 1.2 - rewrite almost all code
        - support for unlimited diemsions arrays
        - now you can choose which type of data you want to store in array
          (string, integer, pointer, variant)
        - or you can write own class based on TCustomAssocArray and use as many
          field as you want ;)
  ] 1.1 - added variants support
        - you can choose (pointers/variants) with $DEFINE switch
  ] 1.0 - first release, work only with pointers
        - arrays have only one diemension
}
unit assoca;
{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

interface

uses
  assocabase, variants;
  
type
  TAssocInt = class(TCustomAssocArray)
  private
    FValue: Integer;
    function GetItem(AName: string): TAssocInt; reintroduce;
  public
    constructor Create;
    property Items[const AName: string]: TAssocInt read GetItem; default;
    property Value: Integer read FValue write FValue;
  end;
  
  TAssocStr = class(TCustomAssocArray)
  private
    FValue: string;
    function GetItem(AName: string): TAssocStr; reintroduce;
  public
    constructor Create;
    property Items[const AName: string]: TAssocStr read GetItem; default;
    property Value: string read FValue write FValue;
  end;
  
  TAssocPtr = class(TCustomAssocArray)
  private
    FValue: Pointer;
    function GetItem(AName: string): TAssocPtr; reintroduce;
  public
    constructor Create;
    property Items[const AName: string]: TAssocPtr read GetItem; default;
    property Value: Pointer read FValue write FValue;
  end;
  
  TAssocVar = class(TCustomAssocArray)
  private
    FValue: Variant;
    function GetItem(AName: Variant): TAssocVar; reintroduce;
  public
    constructor Create;
    property Items[const AName: Variant]: TAssocVar read GetItem; default;
    property Value: Variant read FValue write FValue;
  end;  

  function DoIndent(lvl: Integer): string;
  
implementation

function DoIndent(lvl: Integer): string;
var
  I: integer;
begin
  Result := '';
  for I := 0 to lvl do
    Result := Result + '  ';
end;

{ TAssocInt }
constructor TAssocInt.Create;
begin
  inherited Create;
  MagicClass := TAssocInt;
end;

function TAssocInt.GetItem(AName: string): TAssocInt;
begin
  Result := TAssocInt(inherited GetItem(AName));
end;

{ TAssocStr }
constructor TAssocStr.Create;
begin
  inherited Create;
  MagicClass := TAssocStr;
end;

function TAssocStr.GetItem(AName: string): TAssocStr;
begin
  Result := TAssocStr(inherited GetItem(AName));
end;

{ TAssocPtr }
constructor TAssocPtr.Create;
begin
  inherited Create;
  MagicClass := TAssocPtr;
end;

function TAssocPtr.GetItem(AName: string): TAssocPtr;
begin
  Result := TAssocPtr(inherited GetItem(AName));
end;

{ TAssocVar }
constructor TAssocVar.Create;
begin
  inherited Create;
  MagicClass := TAssocVar;
end;

function TAssocVar.GetItem(AName: Variant): TAssocVar;
begin
  Result := TAssocVar(inherited GetItem(AName));
end;

end.
